#
# -*- coding: utf-8 -*-
#
# Interface for RaiTV
#

import gtk, pygtk

## Costruisco un po' di oggeti che poi
## avrò bisogno di recuperare

from VideoWidget import VideoWidget
from ChannelLoader import ChannelList

class UI():
    
    def __init__(self):
        """Recupera tutti gli oggetti necessari aprendo
        il file .ui e costruisce quelli che mancano"""

        self.builder = gtk.Builder()
        self.builder.add_from_file("ui/RaiTV.ui")

        self.win = self.builder.get_object("win")
        self.listacanali = self.builder.get_object("listacanali")

        ## Lista dei canali (in astratto)
        self.channellist = ChannelList()

       
        ## Questo hbox è quello dove dobbiamo inserire
        ## la videowidget
        self.hbox1 = self.builder.get_object("hbox1")
        
        self.videowidget = VideoWidget()
        self.hbox1.pack_start(self.videowidget)
        
        ## Qualche setting prima di partire
        self.win.resize(640,480)

        ## Carico i pulsanti
        self.stop_btn, self.play_btn, self.pause_btn, self.record_btn, self.updatelist = \
        self.builder.get_object("stop"), self.builder.get_object("play"), \
        self.builder.get_object("pause"), self.builder.get_object("record"), \
        self.builder.get_object("updatelist")

        ## La statusbar
        self.statusbar = self.builder.get_object("statusbar")
        self.sb_info("Applicazione inizializzata")

        self.connect_buttons()


        ## Connettiamo la richiesta di uscire a qualcosa che lo gestisca
        self.win.connect("destroy", self.destroy)

    def show_all(self):
        """Mostra tutta l'interfaccia"""
        self.win.show_all()

    def sb_info(self, text):
        """Pubblica delle informazioni nella statusbar"""
        assert self.statusbar
        id = self.statusbar.get_context_id("info")
        self.statusbar.push(id, "Info: " + text)

    def connect_buttons(self):
        """Connette i bottoni con le relative azioni"""
        self.stop_btn.connect("clicked", lambda w: self.videowidget.stop() )
        self.play_btn.connect("clicked", lambda w: self.videowidget.play() )
        self.pause_btn.connect("clicked", lambda w: self.videowidget.pause() )
        self.updatelist.connect("clicked", lambda w: self.channellist.updateChannels() )

    def start_video(self):
        """Avvia il video"""
        self.videowidget.registerXID()
        self.videowidget.load_video("file:///home/leonardo/Video/The.Big.Bang.Theory.S03E02.HDTV.XviD-XII.avi")
        # self.videowidget.load_video("mms://livestream.rai.it.edgestreams.net/reflector:64084?auth=daEcjcOancgdlaecAdqdccmdwbZbkb0aHd.-bk6_3l-b4-JlruuGt&aifp=V001")
        # self.videowidget.load_video("mms://livestream.rai.it.edgestreams.net/reflector:64084?auth=daEcvcIa9clbgaEbjbfbFdHc_dkcCbUb7dQ-bk7abm-b4-BlvusGo&aifp=V001")

    def destroy(self, w):
        """Chiamata per distruggere l'interfaccia"""
        
        ## Fermiamo il video
        self.videowidget.stop()

        ## e ce ne andiamo
        gtk.main_quit()




